<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MemberSearch StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MemberSearch
 * @subpackage Structs
 */
class MemberSearch extends AbstractStructBase
{
    /**
     * The Areas
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Areas;
    /**
     * The CellPhone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CellPhone;
    /**
     * The ClassId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ClassId;
    /**
     * The Craft
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Craft;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Email;
    /**
     * The Firstname
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Firstname;
    /**
     * The FullName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FullName;
    /**
     * The HomePhone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HomePhone;
    /**
     * The IsAvail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsAvail;
    /**
     * The Lastname
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Lastname;
    /**
     * The MemberId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $MemberId;
    /**
     * The MimeType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MimeType;
    /**
     * The Resume
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Resume;
    /**
     * The State
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $State;
    /**
     * Constructor method for MemberSearch
     * @uses MemberSearch::setAreas()
     * @uses MemberSearch::setCellPhone()
     * @uses MemberSearch::setClassId()
     * @uses MemberSearch::setCraft()
     * @uses MemberSearch::setEmail()
     * @uses MemberSearch::setFirstname()
     * @uses MemberSearch::setFullName()
     * @uses MemberSearch::setHomePhone()
     * @uses MemberSearch::setIsAvail()
     * @uses MemberSearch::setLastname()
     * @uses MemberSearch::setMemberId()
     * @uses MemberSearch::setMimeType()
     * @uses MemberSearch::setResume()
     * @uses MemberSearch::setState()
     * @param string $areas
     * @param string $cellPhone
     * @param int $classId
     * @param string $craft
     * @param string $email
     * @param string $firstname
     * @param string $fullName
     * @param string $homePhone
     * @param bool $isAvail
     * @param string $lastname
     * @param int $memberId
     * @param string $mimeType
     * @param string $resume
     * @param string $state
     */
    public function __construct($areas = null, $cellPhone = null, $classId = null, $craft = null, $email = null, $firstname = null, $fullName = null, $homePhone = null, $isAvail = null, $lastname = null, $memberId = null, $mimeType = null, $resume = null, $state = null)
    {
        $this
            ->setAreas($areas)
            ->setCellPhone($cellPhone)
            ->setClassId($classId)
            ->setCraft($craft)
            ->setEmail($email)
            ->setFirstname($firstname)
            ->setFullName($fullName)
            ->setHomePhone($homePhone)
            ->setIsAvail($isAvail)
            ->setLastname($lastname)
            ->setMemberId($memberId)
            ->setMimeType($mimeType)
            ->setResume($resume)
            ->setState($state);
    }
    /**
     * Get Areas value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAreas()
    {
        return isset($this->Areas) ? $this->Areas : null;
    }
    /**
     * Set Areas value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $areas
     * @return \StructType\MemberSearch
     */
    public function setAreas($areas = null)
    {
        // validation for constraint: string
        if (!is_null($areas) && !is_string($areas)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($areas, true), gettype($areas)), __LINE__);
        }
        if (is_null($areas) || (is_array($areas) && empty($areas))) {
            unset($this->Areas);
        } else {
            $this->Areas = $areas;
        }
        return $this;
    }
    /**
     * Get CellPhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCellPhone()
    {
        return isset($this->CellPhone) ? $this->CellPhone : null;
    }
    /**
     * Set CellPhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cellPhone
     * @return \StructType\MemberSearch
     */
    public function setCellPhone($cellPhone = null)
    {
        // validation for constraint: string
        if (!is_null($cellPhone) && !is_string($cellPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cellPhone, true), gettype($cellPhone)), __LINE__);
        }
        if (is_null($cellPhone) || (is_array($cellPhone) && empty($cellPhone))) {
            unset($this->CellPhone);
        } else {
            $this->CellPhone = $cellPhone;
        }
        return $this;
    }
    /**
     * Get ClassId value
     * @return int|null
     */
    public function getClassId()
    {
        return $this->ClassId;
    }
    /**
     * Set ClassId value
     * @param int $classId
     * @return \StructType\MemberSearch
     */
    public function setClassId($classId = null)
    {
        // validation for constraint: int
        if (!is_null($classId) && !(is_int($classId) || ctype_digit($classId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($classId, true), gettype($classId)), __LINE__);
        }
        $this->ClassId = $classId;
        return $this;
    }
    /**
     * Get Craft value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCraft()
    {
        return isset($this->Craft) ? $this->Craft : null;
    }
    /**
     * Set Craft value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $craft
     * @return \StructType\MemberSearch
     */
    public function setCraft($craft = null)
    {
        // validation for constraint: string
        if (!is_null($craft) && !is_string($craft)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($craft, true), gettype($craft)), __LINE__);
        }
        if (is_null($craft) || (is_array($craft) && empty($craft))) {
            unset($this->Craft);
        } else {
            $this->Craft = $craft;
        }
        return $this;
    }
    /**
     * Get Email value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmail()
    {
        return isset($this->Email) ? $this->Email : null;
    }
    /**
     * Set Email value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $email
     * @return \StructType\MemberSearch
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        if (is_null($email) || (is_array($email) && empty($email))) {
            unset($this->Email);
        } else {
            $this->Email = $email;
        }
        return $this;
    }
    /**
     * Get Firstname value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstname()
    {
        return isset($this->Firstname) ? $this->Firstname : null;
    }
    /**
     * Set Firstname value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstname
     * @return \StructType\MemberSearch
     */
    public function setFirstname($firstname = null)
    {
        // validation for constraint: string
        if (!is_null($firstname) && !is_string($firstname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstname, true), gettype($firstname)), __LINE__);
        }
        if (is_null($firstname) || (is_array($firstname) && empty($firstname))) {
            unset($this->Firstname);
        } else {
            $this->Firstname = $firstname;
        }
        return $this;
    }
    /**
     * Get FullName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFullName()
    {
        return isset($this->FullName) ? $this->FullName : null;
    }
    /**
     * Set FullName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fullName
     * @return \StructType\MemberSearch
     */
    public function setFullName($fullName = null)
    {
        // validation for constraint: string
        if (!is_null($fullName) && !is_string($fullName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fullName, true), gettype($fullName)), __LINE__);
        }
        if (is_null($fullName) || (is_array($fullName) && empty($fullName))) {
            unset($this->FullName);
        } else {
            $this->FullName = $fullName;
        }
        return $this;
    }
    /**
     * Get HomePhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHomePhone()
    {
        return isset($this->HomePhone) ? $this->HomePhone : null;
    }
    /**
     * Set HomePhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $homePhone
     * @return \StructType\MemberSearch
     */
    public function setHomePhone($homePhone = null)
    {
        // validation for constraint: string
        if (!is_null($homePhone) && !is_string($homePhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($homePhone, true), gettype($homePhone)), __LINE__);
        }
        if (is_null($homePhone) || (is_array($homePhone) && empty($homePhone))) {
            unset($this->HomePhone);
        } else {
            $this->HomePhone = $homePhone;
        }
        return $this;
    }
    /**
     * Get IsAvail value
     * @return bool|null
     */
    public function getIsAvail()
    {
        return $this->IsAvail;
    }
    /**
     * Set IsAvail value
     * @param bool $isAvail
     * @return \StructType\MemberSearch
     */
    public function setIsAvail($isAvail = null)
    {
        // validation for constraint: boolean
        if (!is_null($isAvail) && !is_bool($isAvail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isAvail, true), gettype($isAvail)), __LINE__);
        }
        $this->IsAvail = $isAvail;
        return $this;
    }
    /**
     * Get Lastname value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastname()
    {
        return isset($this->Lastname) ? $this->Lastname : null;
    }
    /**
     * Set Lastname value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastname
     * @return \StructType\MemberSearch
     */
    public function setLastname($lastname = null)
    {
        // validation for constraint: string
        if (!is_null($lastname) && !is_string($lastname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastname, true), gettype($lastname)), __LINE__);
        }
        if (is_null($lastname) || (is_array($lastname) && empty($lastname))) {
            unset($this->Lastname);
        } else {
            $this->Lastname = $lastname;
        }
        return $this;
    }
    /**
     * Get MemberId value
     * @return int|null
     */
    public function getMemberId()
    {
        return $this->MemberId;
    }
    /**
     * Set MemberId value
     * @param int $memberId
     * @return \StructType\MemberSearch
     */
    public function setMemberId($memberId = null)
    {
        // validation for constraint: int
        if (!is_null($memberId) && !(is_int($memberId) || ctype_digit($memberId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($memberId, true), gettype($memberId)), __LINE__);
        }
        $this->MemberId = $memberId;
        return $this;
    }
    /**
     * Get MimeType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMimeType()
    {
        return isset($this->MimeType) ? $this->MimeType : null;
    }
    /**
     * Set MimeType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mimeType
     * @return \StructType\MemberSearch
     */
    public function setMimeType($mimeType = null)
    {
        // validation for constraint: string
        if (!is_null($mimeType) && !is_string($mimeType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mimeType, true), gettype($mimeType)), __LINE__);
        }
        if (is_null($mimeType) || (is_array($mimeType) && empty($mimeType))) {
            unset($this->MimeType);
        } else {
            $this->MimeType = $mimeType;
        }
        return $this;
    }
    /**
     * Get Resume value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResume()
    {
        return isset($this->Resume) ? $this->Resume : null;
    }
    /**
     * Set Resume value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $resume
     * @return \StructType\MemberSearch
     */
    public function setResume($resume = null)
    {
        // validation for constraint: string
        if (!is_null($resume) && !is_string($resume)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resume, true), gettype($resume)), __LINE__);
        }
        if (is_null($resume) || (is_array($resume) && empty($resume))) {
            unset($this->Resume);
        } else {
            $this->Resume = $resume;
        }
        return $this;
    }
    /**
     * Get State value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getState()
    {
        return isset($this->State) ? $this->State : null;
    }
    /**
     * Set State value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $state
     * @return \StructType\MemberSearch
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        if (is_null($state) || (is_array($state) && empty($state))) {
            unset($this->State);
        } else {
            $this->State = $state;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MemberSearch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
