<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatesResponse StructType
 * @subpackage Structs
 */
class StatesResponse extends AbstractStructBase
{
    /**
     * The StatesResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfNameValue
     */
    public $StatesResult;
    /**
     * Constructor method for StatesResponse
     * @uses StatesResponse::setStatesResult()
     * @param \ArrayType\ArrayOfNameValue $statesResult
     */
    public function __construct(\ArrayType\ArrayOfNameValue $statesResult = null)
    {
        $this
            ->setStatesResult($statesResult);
    }
    /**
     * Get StatesResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfNameValue|null
     */
    public function getStatesResult()
    {
        return isset($this->StatesResult) ? $this->StatesResult : null;
    }
    /**
     * Set StatesResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfNameValue $statesResult
     * @return \StructType\StatesResponse
     */
    public function setStatesResult(\ArrayType\ArrayOfNameValue $statesResult = null)
    {
        if (is_null($statesResult) || (is_array($statesResult) && empty($statesResult))) {
            unset($this->StatesResult);
        } else {
            $this->StatesResult = $statesResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StatesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
